<template>
  <div class="q-pa-md">
    <q-table
      grid
      class="space"
      grid-header
      :title="`Produse din categoria: ${$route.params.category}`"
      :data="productList"
      :columns="columns"
      row-key="id"
      :filter="filter"
      hide-header
      cursor-pointer
    >
      <template v-slot:top-right>
        <q-input borderless dense v-model="filter" placeholder="Search">
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:item="props">
        <q-card class="col-xs-12 col-sm-3 col-2 q-ma-lg">
          <q-card-section>
            <q-list dense>
              <q-item v-for="col in props.cols" :key="col.name">
                <q-item-section v-if="col.name === 'productImage'">
                  <q-img :src="col.value" style="width: 100%"></q-img>
                </q-item-section>
                <q-item-section class="text-center" v-else-if="col.name === 'productPrice'">
                  <q-item-label>{{ col.value }} RON</q-item-label>
                </q-item-section>
                <q-item-section v-else class="text-center">
                  <q-item-label>{{ col.value }}</q-item-label>
                </q-item-section>
              </q-item>
              <q-card-actions align="center">
                <q-btn
                  flat
                  class="text-weight-medium"
                  color="accent"
                  @click="openProduct(props.row.id)"
                  icon="search"
                />
              </q-card-actions>
            </q-list>
          </q-card-section>
        </q-card>
      </template>
    </q-table>
  </div>
</template>

<script>
export default {
  name: "categoryPage",
  data() {
    return {
      filter: "",
      pagination: {
        rowsPerPage: 100,
      },
      productList: [],
      columns: [
        { name: "productImage", field: "image", sortable: false },

        { name: "productName", field: "name", sortable: true },
        { name: "productPrice", field: "price", sortable: true },
      ],
    };
  },
  methods: {
    openProduct(productId) {
      this.$router.push({ name: "product", params: { product: productId } });
    },
  },
  mounted() {
    this.$store.dispatch("adminData/loadCategories");
    const category = this.categories.find(
      (item) => item.name == this.$route.params.category
    );
    this.productList = this.products.filter(
      (item) => item.categoryId === category.id
    );
  },
  computed: {
    categories() {
      return this.$store.getters["adminData/getCategories"];
    },
    products() {
      return this.$store.getters["adminData/getProducts"];
    },
  },
  watch: {
    $route(to, from) {
      const category = this.categories.find(
        (item) => item.name == this.$route.params.category
      );
      this.productList = this.products.filter(
        (item) => item.categoryId === category.id
      );
    },
  },
};
</script>

<style lang="scss" scoped>
.q-table__grid-content {
  background-color: $primary;
}

.space {
  margin-bottom: 70px;
}
</style>